﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Reactive;
using System.Reactive.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace RxSample.Universal
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            //grid.PointerMoved += grid_PointerMoved;
            //grid.PointerPressed += grid_PointerPressed;
            //grid.PointerReleased += grid_PointerReleased;

            //FromEvent가 있고 FromEventPattern이 있음
            IObservable<EventPattern<PointerRoutedEventArgs>> mouseMoveEvent = Observable.FromEventPattern<PointerRoutedEventArgs>(grid, "PointerMoved");
            IObservable<EventPattern<PointerRoutedEventArgs>> mousePressedEvent = Observable.FromEventPattern<PointerRoutedEventArgs>(grid, "PointerPressed");
            IObservable<EventPattern<PointerRoutedEventArgs>> mouseReleasedEvent = Observable.FromEventPattern<PointerRoutedEventArgs>(grid, "PointerReleased");
            var dragDropEvent = mouseMoveEvent.SkipUntil(mousePressedEvent).TakeUntil(mouseReleasedEvent).Repeat();
            dragDropEvent.Subscribe(async evt =>
            {
                await Task.Delay(1000);
                var pos = evt.EventArgs.GetCurrentPoint(this);
                Canvas.SetTop(ImgImage, pos.Position.Y);
                Canvas.SetLeft(ImgImage, pos.Position.X);
            });

        }

        private bool _canMove;

        void grid_PointerReleased(object sender, PointerRoutedEventArgs e)
        {
            _canMove = false;
        }

        void grid_PointerPressed(object sender, PointerRoutedEventArgs e)
        {
            _canMove = true;
        }

        async void grid_PointerMoved(object sender, PointerRoutedEventArgs e)
        {
            if (_canMove == false) return;

            await Task.Delay(1000);
            var pos = e.GetCurrentPoint(this);
            Canvas.SetTop(ImgImage, pos.Position.Y);
            Canvas.SetLeft(ImgImage, pos.Position.X);
        }
    }
}
